/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel;

import org.eclipse.core.runtime.Plugin;
import org.fortiss.tooling.kernel.utils.ServicesUtils;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: 66981719E8162DD7966D7A81934C07C3
 */
public class ToolingKernelActivator extends Plugin {

	/** The plug-in ID. */
	public static final String PLUGIN_ID = ToolingKernelActivator.class.getPackage().getName(); //$NON-NLS-1$

	/** The shared instance. */
	private static ToolingKernelActivator plugin;

	/** {@inheritDoc} */
	@Override
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
		System.out.println("[Plugin] " + PLUGIN_ID + " started.");

		// FIXME: move this registration
		// ToolingKernel.registerModelStorageProvider(new EclipseResourceStorageProvider());
	}

	/** {@inheritDoc} */
	@Override
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/** Returns the shared instance. */
	public static ToolingKernelActivator getDefault() {
		return plugin;
	}

	/** Returns the service for the given interface. */
	public static <SERVICE> SERVICE getService(Class<SERVICE> clazz) {
		return ServicesUtils.getService(plugin.getBundle(), clazz);
	}

	/** Releases the OSGi service. */
	public static boolean ungetService(Class<?> clazz) {
		return ServicesUtils.ungetService(plugin.getBundle(), clazz);
	}
}
